// RegFind.cpp : main source file for RegFind.exe
//

#include "stdafx.h"

#include <atlframe.h>
#include <atlctrls.h>
#include <atldlgs.h>
#include <atlctrlw.h>

#include "resource.h"

#include "ShowErrors.h"

#include "aboutdlg.h"


#include "RegFind.h"

#include "Filedata.h"
#include "RegKeyTools.h"
#include "ThreadTool.h"

#include "maindlg.h"

CAppModule _Module;

CRegKeyTools gRegKeyTools;
THREADINFO gThreadInfo;

int Run(LPTSTR /*lpstrCmdLine*/ = NULL, int nCmdShow = SW_SHOWDEFAULT)
{
	CMessageLoop theLoop;
	_Module.AddMessageLoop(&theLoop);

	// Initial public setting
	memset((LPVOID)&gThreadInfo, 0, sizeof(THREADINFO));
	gThreadInfo.pRegKeyTools = &gRegKeyTools; 
	gThreadInfo.hThreadTerminated = ::CreateEvent(NULL, TRUE, TRUE, NULL);
	gThreadInfo.curState.CS_StateOptions.Init();

	CMainDlg dlgMain;
	dlgMain.m_pThreadInfo = &gThreadInfo;

	if(dlgMain.Create(NULL) == NULL)
	{
		ATLTRACE(_T("Main dialog creation failed!\n"));
		return 0;
	}

	dlgMain.ShowWindow(nCmdShow);

	int nRet = theLoop.Run();

	_Module.RemoveMessageLoop();
	
	// Release all public objects
	if (gThreadInfo.hThreadTerminated != NULL)
	{
		::CloseHandle(gThreadInfo.hThreadTerminated);
		gThreadInfo.hThreadTerminated = NULL;
	}
	gThreadInfo.curState.CS_StateOptions.Term(); 

	return nRet;
}

int WINAPI _tWinMain(HINSTANCE hInstance, HINSTANCE /*hPrevInstance*/, LPTSTR lpstrCmdLine, int nCmdShow)
{
	HRESULT hRes = ::CoInitialize(NULL);
// If you are running on NT 4.0 or higher you can use the following call instead to 
// make the EXE free threaded. This means that calls come in on a random RPC thread.
//	HRESULT hRes = ::CoInitializeEx(NULL, COINIT_MULTITHREADED);
	ATLASSERT(SUCCEEDED(hRes));

#if (_WIN32_IE >= 0x0300)
	INITCOMMONCONTROLSEX iccx;
	iccx.dwSize = sizeof(iccx);
	iccx.dwICC = ICC_COOL_CLASSES | ICC_BAR_CLASSES;
	BOOL bRet = ::InitCommonControlsEx(&iccx);
	bRet;
	ATLASSERT(bRet);
#else
	::InitCommonControls();
#endif

	hRes = _Module.Init(NULL, hInstance);
	ATLASSERT(SUCCEEDED(hRes));


	int nRet = Run(lpstrCmdLine, nCmdShow);

	_Module.Term();
	::CoUninitialize();

	return nRet;
}
