// RegKeyTools.h: interface for the RegKeyTools class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_REGKEYTOOLS_H__4D834603_02C3_11D6_A1A1_009027A4D0CE__INCLUDED_)
#define AFX_REGKEYTOOLS_H__4D834603_02C3_11D6_A1A1_009027A4D0CE__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <comdef.h>
#include <vector>
	using namespace std ;
#include <string>
	using namespace std ;

typedef struct _ROOTKEY
{
	HKEY hKey;
	LPCTSTR lpszName;
} ROOTKEY, *LPROOTKEY;

typedef struct _SEARCHINFO
{
	HWND hWndNotify;
	LPSTATE lpCurState;
} SEARCHINFO, *LPSEARCHINFO;

typedef vector<string> STRVECTOR;

#define UTILNAME		_T("RegFind")
#define UTILVERS		_T("1.0")

#define MAXLENROOTNAME	(20)
#define FILEINI			_T("RegFind.ini")
#define FILEKEYSEXCLUDE	_T("ExcludeKeys.txt")
#define SECTIONKYES		_T("ExcludeKeys")
#define SECTIONOPTS		_T("Options")
#define OPTKYES			_T("Keys")
#define OPTKYESDEF		_T("On")
#define OPTVALUES		_T("Values")
#define OPTVALUESDEF	_T("On")
#define OPTDATA			_T("Data")
#define OPTDATADEF		_T("Off")
#define OPTWHOLESTR		_T("WholeString")
#define OPTWHOLESTRDEF	_T("Off")
#define OPTMATCHCASE	_T("MatchCase")
#define OPTMATCHCASEDEF	_T("Off")

#define MAXEXCLUDEKEYS	(100)
#define MAXKEYLEN		(5*MAX_PATH)
#define MAXHOSTLEN		(256)
#define REGFILEEXT		_T(".reg")
#define MAXDATETIME		(120)
#define MAXSIDLEN		(128)

#define SEARCHTERMINATED	_T("\r\n; ** The process of search was interrupted by the user **")

class CFileData;

class CRegKeyTools  
{
public:
	void SetModified(BOOL bModified = TRUE);
	CRegKeyTools();
	virtual ~CRegKeyTools();
	LPCTSTR GetFileResult();
	BOOL IsTerminated();
	BOOL Find();

	_TCHAR m_szSearchText[MAX_PATH];
	BOOL m_bKeys;
	BOOL m_bValues;
	BOOL m_bData;
	BOOL m_bWholeString;
	BOOL m_bMatchCase;
	BOOL m_bShowResult;
	HANDLE m_hTerminate;
	SEARCHINFO m_SearhInfo;

protected:
	static WSADATA m_wsaData;
	static _TCHAR m_szFileIni[MAX_PATH];
	static ROOTKEY m_RootKeys[];
	static LPCTSTR m_FileHeader[];
	BOOL* m_lpResultKeys;
	int m_nMaxRootItems;
	BOOL m_bIsModified;
	BOOL m_bTerminated;
	BOOL m_bIsNewExcludeKeys;
	LPCTSTR m_lpszFileIni;
	LPCTSTR m_lpszSectionKeys;
	_TCHAR m_szSearchTxt[MAX_PATH];
	_TCHAR m_szCurKey[MAXKEYLEN];
	_TCHAR m_szFileOut[MAX_PATH];
	_TCHAR m_szBuffer[MAX_PATH];
	fpos_t m_curFilePos;
	time_t m_sysTime;
	struct tm m_curTime;
	_TCHAR m_szCurTime[MAXDATETIME];
	_TCHAR m_szUserSID[MAXSIDLEN];
	CHAR m_szLocalHostName[MAXHOSTLEN];
	CFileData m_fileData;
	STRVECTOR m_vecExcludeKeys;
	
	BOOL GetUserSID();
	void CloseFileData();
	BOOL ReadSettings();
	BOOL WriteStr(LPCTSTR lpszData);
	BOOL WriteCurKey();
	BOOL WriteValueName(LPCTSTR lpszValueName, DWORD dwValue);
	BOOL Write(LPCTSTR lpszData);
	BOOL GetTextualSid(PSID pSid, LPTSTR szTextualSid, LPDWORD dwBufferLen);
	BOOL GetFileIni();
	void WriteSettings();
	LPCTSTR BoolToStr(BOOL bOption);
#if _SECURE_ATL
	BOOL StrToBool(LPTSTR lpszOpt, size_t lenBuff);
	BOOL CompareStr(LPCTSTR lpszDataStr, LPTSTR lpszBuffer, BOOL bInKey, size_t lenBuffer);
#else
	BOOL StrToBool(LPTSTR lpszOpt);
	BOOL CompareStr(LPCTSTR lpszDataStr, LPTSTR lpszBuffer, BOOL bInKey = FALSE);
#endif
	BOOL CreateFile();
	void ClearResults();
	BOOL FindInNode(HKEY hKey, LPTSTR lpszSubkey = NULL);
	BOOL GetLocalHostName(LPSTR lpszLocalHostName, size_t &nlen);
};

#endif // !defined(AFX_REGKEYTOOLS_H__4D834603_02C3_11D6_A1A1_009027A4D0CE__INCLUDED_)
