// ShowErrors.cpp 
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "ShowErrors.h"
void ShowErrorMsg(HRESULT hr, LPCTSTR lpszContextMsg)
{
	LPVOID lpMsgBuf;
	_TCHAR lpszCodes[50];
	::FormatMessage( 
		FORMAT_MESSAGE_ALLOCATE_BUFFER|FORMAT_MESSAGE_FROM_SYSTEM,
		NULL,
		hr,
		MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // Default language
		(LPTSTR)&lpMsgBuf,
		0,
		NULL);
	size_t nLenCodes = _tcslen((LPCTSTR)lpszCodes);
	size_t nLenContext = _tcslen(lpszContextMsg);
	size_t nLenOutTxt = _tcslen((LPCTSTR)lpMsgBuf)+nLenContext+52;
	LPTSTR lpszOutTxt = ::new _TCHAR[nLenOutTxt];
	_ASSERTE(lpszOutTxt != NULL);
#if _SECURE_ATL
	errno_t err = strcpy_s(lpszOutTxt, nLenOutTxt, (LPCTSTR)lpMsgBuf);
	_ASSERTE(err == NOERROR);
	sprintf_s((LPTSTR)lpszCodes, nLenCodes,
		_T("Facility = %d, Severity = %d, Scode = %d\n"),
		HRESULT_FACILITY(hr), HRESULT_SEVERITY(hr), (SCODE)SCODE_CODE(hr)); 
	err = strcat_s(lpszOutTxt, nLenContext, (LPCTSTR)lpszCodes);
	_ASSERTE(err == NOERROR);
	if (nLenContext)
		strcat_s(lpszOutTxt, nLenContext, lpszContextMsg);
#else
	_tcscpy(lpszOutTxt, (LPCTSTR)lpMsgBuf);
	_stprintf((LPTSTR)lpszCodes,
		_T("Facility = %d, Severity = %d, Scode = %d\n"),
		HRESULT_FACILITY(hr), HRESULT_SEVERITY(hr), (SCODE)SCODE_CODE(hr)); 
	_tcscat(lpszOutTxt, (LPCTSTR)lpszCodes);
	if (nLenContext)
		_tcscat(lpszOutTxt, lpszContextMsg);
#endif
	::MessageBeep((DWORD)(-1));
	::MessageBox(NULL, (LPCTSTR)lpszOutTxt, _T("Error:"), MB_OK|MB_ICONERROR);
	::delete [] lpszOutTxt;
	::LocalFree(lpMsgBuf);
}
