// aboutdlg.h : interface of the CAboutDlg class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_ABOUTDLG_H__A760C2EB_05CD_11D6_A1A7_009027A4D0CE__INCLUDED_)
#define AFX_ABOUTDLG_H__A760C2EB_05CD_11D6_A1A7_009027A4D0CE__INCLUDED_

class CAboutDlg : public CDialogImpl<CAboutDlg>
{
public:
	enum { IDD = IDD_ABOUTBOX };

	BEGIN_MSG_MAP(CAboutDlg)
		MESSAGE_HANDLER(WM_INITDIALOG, OnInitDialog)
		MESSAGE_HANDLER(WM_CLOSE, OnClose)
		MESSAGE_HANDLER(WM_CTLCOLORSTATIC, OnCtlColor)
		COMMAND_HANDLER(IDC_URL, BN_CLICKED, OnClickedUrl)
		COMMAND_HANDLER(IDC_EMAIL, BN_CLICKED, OnClickedEmail) 
		COMMAND_ID_HANDLER(IDOK, OnCloseCmd)
	END_MSG_MAP()
	
	CAboutDlg() :
		m_hCursor(NULL),
		m_hWndUrl(NULL),
		m_hWndMail(NULL),
		m_hFtUrl(NULL),
		m_hFtMail(NULL)
	{
		m_clrUrlText = RGB(0,0,255);
		m_clrUrlBkgnd = ::GetSysColor(COLOR_3DFACE); //COLOR_BTNFACE
	}

	~CAboutDlg()
	{
		if (m_hCursor != NULL)
		{
			DestroyCursor(m_hCursor);
			m_hCursor = NULL;
		}
		if (m_hFtUrl != NULL)
		{
			::DeleteObject((HGDIOBJ)m_hFtUrl);
			m_hFtUrl = NULL;
		}
		if (m_hFtMail != NULL)
		{
			::DeleteObject((HGDIOBJ)m_hFtMail);
			m_hFtMail = NULL;
		}
	}

protected:
	LRESULT OnCtlColor(UINT /*uMsg*/, WPARAM wParam, LPARAM lParam, BOOL& /*bHandled*/)
	{
		HWND hWnd = (HWND)lParam;
		if (hWnd != NULL && (hWnd == m_hWndUrl || hWnd == m_hWndMail))
		{
			HBRUSH hBrush = NULL;
			HDC hDC = (HDC)wParam;
			if (hDC != NULL)
			{
				hBrush = (HBRUSH)::GetCurrentObject(hDC, OBJ_BRUSH);
				if (hBrush != NULL)
				{
					::SetTextColor(hDC, m_clrUrlText);
					::SetBkColor(hDC, m_clrUrlBkgnd);
				}
			}
			return (LRESULT)hBrush;
		}
		else
			return NULL;
	}
	
	LRESULT OnInitDialog(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/)
	{
		CenterWindow(GetParent());

		// Cursor
		HINSTANCE hResourceInstance = _Module.GetResourceInstance();
		_ASSERTE(hResourceInstance != NULL);
		m_hCursor = ::LoadCursor(hResourceInstance, MAKEINTRESOURCE(IDC_CURSORURL));
		_ASSERTE(m_hCursor != NULL);
		
		// URL font
		m_hWndUrl = GetDlgItem(IDC_URL);
		_ASSERTE(m_hWndUrl != NULL);
		m_hFtUrl = (HFONT)::SendMessage(m_hWndUrl, WM_GETFONT, 0, 0); 
		_ASSERTE(m_hFtUrl != NULL);
		LOGFONT lf;
		size_t nSize = sizeof(LOGFONT);
		memset((LPVOID)&lf, 0, nSize);
		nSize = ::GetObject((HGDIOBJ)m_hFtUrl, nSize, (LPVOID)&lf);
		_ASSERTE(nSize != NULL);
		lf.lfUnderline = TRUE;
		m_hFtUrl = CreateFontIndirect(&lf);
		_ASSERTE(m_hFtUrl != NULL);
		::SendMessage(m_hWndUrl, WM_SETFONT, (WPARAM)m_hFtUrl, 0);
		::SetClassLong(m_hWndUrl, GCL_HCURSOR, (LONG)m_hCursor);  

		// EMAIL font
		m_hWndMail = GetDlgItem(IDC_EMAIL);
		_ASSERTE(m_hWndMail != NULL);
		m_hFtMail = (HFONT)::SendMessage(m_hWndMail, WM_GETFONT, 0, 0); 
		_ASSERTE(m_hFtMail != NULL);
		nSize = sizeof(LOGFONT);
		memset((LPVOID)&lf, 0, nSize);
		nSize = ::GetObject((HGDIOBJ)m_hFtMail, nSize, (LPVOID)&lf);
		_ASSERTE(nSize != NULL);
		lf.lfUnderline = TRUE;
		m_hFtMail = CreateFontIndirect(&lf);
		_ASSERTE(m_hFtMail != NULL);
		::SendMessage(m_hWndMail, WM_SETFONT, (WPARAM)m_hFtMail, 0);
		::SetClassLong(m_hWndMail, GCL_HCURSOR, (LONG)m_hCursor);  

		return TRUE;
	}

	LRESULT OnClose(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/)
	{
		EndDialog(0);
		return 0;
	}

	LRESULT OnCloseCmd(WORD /*wNotifyCode*/, WORD wID, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
	{
		EndDialog(wID);
		return 0;
	}

	LRESULT OnClickedUrl(WORD /*wNotifyCode*/, WORD /*wID*/, HWND hWndCtl, BOOL& /*bHandled*/)
	{
		ShowDoc(hWndCtl);
		return 0;
	}
	
	LRESULT OnClickedEmail(WORD /*wNotifyCode*/, WORD /*wID*/, HWND hWndCtl, BOOL& /*bHandled*/)
	{
		ShowDoc(hWndCtl);
		return 0;
	}

	void ShowDoc(HWND hWndCtl)
	{
		if (hWndCtl == NULL)
			return ;
		_TCHAR szAddres[MAX_PATH];
		if (::GetWindowText(hWndCtl, szAddres, MAX_PATH) > 0)
			::ShellExecute(NULL, _T("open"), szAddres, NULL, NULL, SW_SHOWMAXIMIZED); 
	}

	COLORREF m_clrUrlText;
	COLORREF m_clrUrlBkgnd;
	HCURSOR m_hCursor;
	HFONT m_hFtUrl;
	HFONT m_hFtMail;
	HWND m_hWndUrl;
	HWND m_hWndMail;
};

#endif // !defined(AFX_ABOUTDLG_H__A760C2EB_05CD_11D6_A1A7_009027A4D0CE__INCLUDED_)
