// maindlg.h : interface of the CMainDlg class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_MAINDLG_H__A760C2EC_05CD_11D6_A1A7_009027A4D0CE__INCLUDED_)
#define AFX_MAINDLG_H__A760C2EC_05CD_11D6_A1A7_009027A4D0CE__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#define STOPCAPTION	_T("&Stop")
#define FINDCAPTION	_T("&Find")

class CMainDlg : public CDialogImpl<CMainDlg>, CUpdateUI<CMainDlg>,
		public CMessageFilter, public CIdleHandler
{
public:
	enum { IDD = IDD_MAINDLG };

	LPTHREADINFO m_pThreadInfo;
	
	CMainDlg() : 
		m_bDestroy(FALSE),
		m_pThreadInfo(NULL),
		m_dwThreadId(0),
		m_hThread(NULL),
		dwOldFoundItems(-1),
		m_bIsModified(FALSE)
	{
		TCHAR szModule1[_MAX_PATH];
		::GetModuleFileName(_Module.GetModuleInstance(), szModule1, _MAX_PATH);
	}

	virtual BOOL PreTranslateMessage(MSG* pMsg)
	{
		return IsDialogMessage(pMsg);
	}

	virtual BOOL OnIdle()
	{
		return FALSE;
	}

	BEGIN_MSG_MAP(CMainDlg)
		MESSAGE_HANDLER(WM_INITDIALOG, OnInitDialog)
		MESSAGE_HANDLER(UM_ENDTHREAD, OnEndThread)
		MESSAGE_HANDLER(UM_STATECHANGED, OnStateChanged)
		MESSAGE_HANDLER(WM_CLOSE, OnClose)
		MESSAGE_HANDLER(WM_DESTROY, OnDestroy)
		COMMAND_ID_HANDLER(ID_APP_ABOUT, OnAppAbout)
		COMMAND_ID_HANDLER(IDC_FIND, OnFind)
		COMMAND_ID_HANDLER(IDCANCEL, OnCancel)
		COMMAND_HANDLER(IDC_TEXT, EN_CHANGE, OnChangeText)
		COMMAND_HANDLER(IDC_CHKDATA, BN_CLICKED, OnClickedData)
		COMMAND_HANDLER(IDC_CHKKYES, BN_CLICKED, OnClickedKyes)
		COMMAND_HANDLER(IDC_CHKVALUES, BN_CLICKED, OnClickedValues)
		COMMAND_HANDLER(IDC_SHOW, BN_CLICKED, OnClickedShow)
		COMMAND_HANDLER(IDC_CHKCASESENS, BN_CLICKED, OnClickedChkSaseSens)
		COMMAND_HANDLER(IDC_CHKSTRWHOLE, BN_CLICKED, OnClickedChkStrWhole)
	END_MSG_MAP()

	BEGIN_UPDATE_UI_MAP(CMainDlg)
	END_UPDATE_UI_MAP()

protected:
	DWORD m_dwThreadId;
	HANDLE m_hThread;
	BOOL m_bDestroy;
	DWORD dwOldFoundItems;
	BOOL m_bIsModified;
	
	LRESULT OnInitDialog(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/)
	{
		// center the dialog on the screen
		CenterWindow();

		// set icons
		HICON hIcon = (HICON)::LoadImage(_Module.GetResourceInstance(), MAKEINTRESOURCE(IDR_MAINFRAME), 
			IMAGE_ICON, ::GetSystemMetrics(SM_CXICON), ::GetSystemMetrics(SM_CYICON), LR_DEFAULTCOLOR);
		SetIcon(hIcon, TRUE);
		HICON hIconSmall = (HICON)::LoadImage(_Module.GetResourceInstance(), MAKEINTRESOURCE(IDR_MAINFRAME), 
			IMAGE_ICON, ::GetSystemMetrics(SM_CXSMICON), ::GetSystemMetrics(SM_CYSMICON), LR_DEFAULTCOLOR);
		SetIcon(hIconSmall, FALSE);

		// register object for message filtering and idle updates
		CMessageLoop* pLoop = _Module.GetMessageLoop();
		pLoop->AddMessageFilter(this);
		pLoop->AddIdleHandler(this);

		UIAddChildWindowContainer(m_hWnd);
		
		HWND hWnd = GetDlgItem(IDC_CURSTATE);
		if (hWnd != NULL) ::SetWindowText(hWnd, _T(""));
		hWnd = GetDlgItem(IDC_CURFOUND);
		if (hWnd != NULL) ::SetWindowText(hWnd, _T(""));
		
		_ASSERTE(m_pThreadInfo != NULL);
		_ASSERTE(m_pThreadInfo->pRegKeyTools != NULL);
		CRegKeyTools* pRegKeyTools = m_pThreadInfo->pRegKeyTools;

		if (pRegKeyTools->m_bKeys)
			CheckDlgButton(IDC_CHKKYES, BST_CHECKED);
		if (pRegKeyTools->m_bValues)
			CheckDlgButton(IDC_CHKVALUES, BST_CHECKED);
		if (pRegKeyTools->m_bData)
			CheckDlgButton(IDC_CHKDATA, BST_CHECKED);
		if (pRegKeyTools->m_bWholeString)
			CheckDlgButton(IDC_CHKSTRWHOLE, BST_CHECKED);
		if (pRegKeyTools->m_bMatchCase)
			CheckDlgButton(IDC_CHKCASESENS, BST_CHECKED);
		
		return TRUE;
	}

	LRESULT OnAppAbout(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
	{
		CAboutDlg dlg;
		dlg.DoModal();
		return 0;
	}

	BOOL EnableFind()
	{
		return ::GetWindowTextLength(GetDlgItem(IDC_TEXT)) != 0 &&
					(IsDlgButtonChecked(IDC_CHKKYES) || 
						IsDlgButtonChecked(IDC_CHKVALUES) || 
						IsDlgButtonChecked(IDC_CHKDATA)); 
	}

	LRESULT OnChangeText(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
	{
		::EnableWindow(GetDlgItem(IDC_FIND), EnableFind());
		return 0;
	}
	LRESULT OnClickedData(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
	{
		::EnableWindow(GetDlgItem(IDC_FIND), EnableFind());
		m_bIsModified = TRUE;
		return 0;
	}
	LRESULT OnClickedKyes(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
	{
		::EnableWindow(GetDlgItem(IDC_FIND), EnableFind());
		m_bIsModified = TRUE;
		return 0;
	}
	LRESULT OnClickedValues(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
	{
		::EnableWindow(GetDlgItem(IDC_FIND), EnableFind());
		m_bIsModified = TRUE;
		return 0;
	}
	LRESULT OnClickedChkSaseSens(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
	{
		m_bIsModified = TRUE;
		return 0;
	}
	LRESULT OnClickedChkStrWhole(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
	{
		m_bIsModified = TRUE;
		return 0;
	}

	// OnClick [Fins|Stop] button
	LRESULT OnFind(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
	{
		HWND hWndCmd = GetDlgItem(IDC_FIND);
		_ASSERTE(hWndCmd != NULL);

		BOOL bIsAction = FALSE;
		if (m_hThread == NULL)
		{
			if (!EnableFind())
				return 0;
			
			if ((bIsAction = Find()))
			{
				::SetWindowText(hWndCmd, STOPCAPTION);
			}
		}
		else
		{
			if ((bIsAction = Stop()))
			{
				::SetWindowText(hWndCmd, FINDCAPTION);
			}
		}
		
		return 0;
	}

	void ResetOptions()
	{
		_ASSERTE(m_pThreadInfo != NULL);
		_ASSERTE(m_pThreadInfo->pRegKeyTools != NULL);
		CRegKeyTools* pRegKeyTools = m_pThreadInfo->pRegKeyTools;

		pRegKeyTools->m_bKeys        = (BOOL)IsDlgButtonChecked(IDC_CHKKYES); 
		pRegKeyTools->m_bValues      = (BOOL)IsDlgButtonChecked(IDC_CHKVALUES); 
		pRegKeyTools->m_bData        = (BOOL)IsDlgButtonChecked(IDC_CHKDATA); 
		pRegKeyTools->m_bWholeString = (BOOL)IsDlgButtonChecked(IDC_CHKSTRWHOLE); 
		pRegKeyTools->m_bMatchCase   = (BOOL)IsDlgButtonChecked(IDC_CHKCASESENS);
		
		if (m_bIsModified)
			pRegKeyTools->SetModified(); 
	}
	
	// Create thread
	BOOL Find()
	{
		// Try set all current search options
		BOOL bRetVal = FALSE;
		_ASSERTE(m_pThreadInfo != NULL);
		_ASSERTE(m_pThreadInfo->pRegKeyTools != NULL);
		CRegKeyTools* pRegKeyTools = m_pThreadInfo->pRegKeyTools;

		// hWndNotify
		HWND hWndNotify = ::GetActiveWindow();
		_ASSERTE(hWndNotify != NULL);
		m_pThreadInfo->hWndNotify = hWndNotify;
		
		// m_szSearchText
		HWND hWnd = GetDlgItem(IDC_TEXT);
		_ASSERTE(hWnd != NULL);
		if (hWnd != NULL)
			::GetWindowText(hWnd, pRegKeyTools->m_szSearchText, MAX_PATH);
		
		// Other options
		ResetOptions();

		pRegKeyTools->m_SearhInfo.hWndNotify = hWndNotify;   
		pRegKeyTools->m_SearhInfo.lpCurState = &m_pThreadInfo->curState;   

		// Try create thread for search-process
		if (m_hThread == NULL)
		{
			// We use CreateThread() in all cases, as we do not use ExitThread() 
			m_hThread = ::CreateThread( 
				NULL,           // no security attributes 
				0,				// use default stack size  
				ThreadProc,		// thread function 
				m_pThreadInfo,	// argument to thread function 
				0,				// use default creation flags 
				&m_dwThreadId	// returns the thread identifier 
				);
			bRetVal = (m_hThread != NULL);

			if (bRetVal)
			{
				::EnableWindow(GetDlgItem(IDC_SHOW), FALSE);
				// Reset ThreadTerminate Event
				if (m_pThreadInfo != NULL
					&& m_pThreadInfo->hThreadTerminated != NULL)
				{
					::ResetEvent(m_pThreadInfo->hThreadTerminated);
					m_pThreadInfo->pRegKeyTools->m_hTerminate = m_pThreadInfo->hThreadTerminated;
				}
			}
		}
		return bRetVal;
	}
	
	// Terminate thread
	BOOL Stop()
	{
		BOOL bRetVal = FALSE;
		if (m_hThread != NULL)
		{
			::EnableWindow(GetDlgItem(IDC_FIND), FALSE);
			if (m_pThreadInfo != NULL && m_pThreadInfo->hThreadTerminated != NULL)
				::SetEvent(m_pThreadInfo->hThreadTerminated);
			bRetVal = TRUE;
		}
		return bRetVal;
	}

	// Check enable close dialog
	BOOL CloseDialog(int nVal)
	{
		BOOL bRetVal = TRUE;
		
		if (m_hThread != NULL)
		{
			if (!m_bDestroy)
			{
				Stop();
				m_bDestroy = TRUE;
			}
			bRetVal = FALSE;
		}
		else
		{
			ResetOptions();			
			DestroyWindow();
		}
		return bRetVal;
	}

	LRESULT OnCancel(WORD /*wNotifyCode*/, WORD wID, HWND /*hWndCtl*/, BOOL& bHandled)
	{
		bHandled = CloseDialog(wID);
		return 0;
	}
	LRESULT OnClose(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& bHandled)
	{
		bHandled = CloseDialog(0);
		return 0;
	}

	LRESULT OnEndThread(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/)
	{
		HWND hWndCmd = GetDlgItem(IDC_FIND);
		if (m_hThread != NULL)
		{
			if (::WaitForSingleObject(m_hThread, INFINITE) == WAIT_OBJECT_0)
			{
				if(hWndCmd != NULL)
					::SetWindowText(hWndCmd, FINDCAPTION);
				
				DWORD dwExitCode = 0;
				if (::GetExitCodeThread(m_hThread, &dwExitCode))
				{
					if (dwExitCode != 0 && !m_bDestroy)
					{
//						_TCHAR szMsg[MAX_PATH];
//						_stprintf(szMsg, _T("Exit code: %d"), dwExitCode); 
//						MessageBox(szMsg, _T("The end search process info:"), MB_OK|MB_ICONWARNING);
					}
				}
				
				if (m_pThreadInfo != NULL && m_pThreadInfo->hThreadTerminated != NULL)
					::ResetEvent(m_pThreadInfo->hThreadTerminated);
				
				::CloseHandle(m_hThread);
				m_hThread = NULL;
				m_dwThreadId = 0;
			}
		}

		if(hWndCmd != NULL)
			::EnableWindow(hWndCmd, TRUE);

		if (!m_bDestroy)
		{
			HWND hWndCmdShow = GetDlgItem(IDC_SHOW);
			if (hWndCmdShow != NULL)
				::EnableWindow(hWndCmdShow, IsFileResult());
		}
		else
			DestroyWindow();
		
		return 0;
	}

	BOOL IsFileResult()
	{
		BOOL bRetVal = FALSE;
		if (m_pThreadInfo != NULL && m_pThreadInfo->pRegKeyTools != NULL)
		{
			LPCTSTR lpszFileName = m_pThreadInfo->pRegKeyTools->GetFileResult();
			if (_tcslen(lpszFileName) != 0)
				bRetVal = (::GetFileAttributes(lpszFileName) != 0xFFFFFFFF);
		}
		return bRetVal;
	}

	LRESULT OnDestroy(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/)
	{
		::PostQuitMessage(0);
		return 0;
	}

	LRESULT OnStateChanged(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/)
	{
		if (m_pThreadInfo != NULL)
		{
			LPSTATE lpState = &m_pThreadInfo->curState;
			if (lpState != NULL)
			{
//				::EnterCriticalSection(&lpState->CS_StateOptions);
#if _SECURE_ATL
				sprintf_s(m_pThreadInfo->szState, MAX_PATH,
					_T("Search: Keys %ld, Values %ld"),
					lpState->dwKeys, lpState->dwValues);
#else
				_stprintf(m_pThreadInfo->szState,
					_T("Search: Keys %ld, Values %ld"),
					lpState->dwKeys, lpState->dwValues);
#endif
				HWND hWnd = GetDlgItem(IDC_CURSTATE);
				if (hWnd != NULL)
					::SetWindowText(hWnd, m_pThreadInfo->szState);
				if (dwOldFoundItems != lpState->dwFoundItems)
				{
#if _SECURE_ATL
					sprintf_s(m_pThreadInfo->szResult, MAX_PATH,
						_T("Found items: %ld"), lpState->dwFoundItems);
#else
					_stprintf(m_pThreadInfo->szResult,
						_T("Found items: %ld"), lpState->dwFoundItems);
#endif
					hWnd = GetDlgItem(IDC_CURFOUND);
					if (hWnd != NULL)
						::SetWindowText(hWnd, m_pThreadInfo->szResult);
					dwOldFoundItems = lpState->dwFoundItems;
				}
//				::LeaveCriticalSection(&lpState->CS_StateOptions);
			}
		}
		return 0;
	}
	LRESULT OnClickedShow(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
	{
		if (IsFileResult())
		{
			LPCTSTR lpszFileName = m_pThreadInfo->pRegKeyTools->GetFileResult();
			HINSTANCE hInst = ::ShellExecute(::GetActiveWindow(),_T("edit"), lpszFileName, NULL, NULL, SW_SHOW);
			if ((DWORD)hInst <= 32)
			{
				_TCHAR szMsg[2*MAX_PATH];
#if _SECURE_ATL
				sprintf_s(szMsg, 2*MAX_PATH, _T(" for file %s"), lpszFileName); 
#else
				_stprintf(szMsg, _T(" for file %s"), lpszFileName); 
#endif
				ShowErrorMsg((HRESULT)hInst, szMsg);
			}
			
		}
		return 0;
	}
};


/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MAINDLG_H__A760C2EC_05CD_11D6_A1A7_009027A4D0CE__INCLUDED_)
